/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;


public class TaskList extends Node {
    private static final String TAG = TaskList.class.getSimpleName(); // TAG用于在日志中标识类名

    private int mIndex; // 任务列表的索引

    private ArrayList<Task> mChildren; // 任务列表的子任务集合

    /**
     * TaskList类的构造方法，初始化mChildren和mIndex。
     */
    public TaskList() {
        super(); // 调用父类Node的构造方法
        mChildren = new ArrayList<Task>(); // 初始化子任务集合
        mIndex = 1; // 初始化索引为1
    }

    /**
     * 生成创建任务列表操作的JSONObject对象
     *
     * @param actionId 操作ID
     * @return 用于表示创建任务列表操作的JSONObject对象
     */
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject(); // 创建一个JSONObject对象js

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE, GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);
            // 将键为GTASK_JSON_ACTION_TYPE的值设置为"create"

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);
            // 将键为GTASK_JSON_ACTION_ID的值设置为actionId

            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mIndex);
            // 将键为GTASK_JSON_INDEX的值设置为mIndex

            // entity_delta
            JSONObject entity = new JSONObject(); // 创建一个JSONObject对象entity
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 将键为GTASK_JSON_NAME的值设为任务列表名称
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null"); // 将键为GTASK_JSON_CREATOR_ID的值设为"null"
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE, GTaskStringUtils.GTASK_JSON_TYPE_GROUP);
            // 将键为GTASK_JSON_ENTITY_TYPE的值设置为GTASK_JSON_TYPE_GROUP
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);
            // 将键为GTASK_JSON_ENTITY_DELTA的值设为entity

        } catch (JSONException e) { // 捕捉JSONException异常
            Log.e(TAG, e.toString()); // 在日志中输出异常信息
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-create jsonobject");
            // 抛出ActionFailureException异常
        }

        return js; // 返回JSONObject对象js
    }


    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // 设置操作类型为更新
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE, GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);

            // 设置操作的ID
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // 设置任务列表的全局ID
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());

            // 创建一个表示任务列表实体变化的JSON对象
            JSONObject entity = new JSONObject();

            // 设置任务列表的名称
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());

            // 设置任务列表是否被删除
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted());

            // 将实体变化JSON对象添加到主JSON对象中
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

        } catch (JSONException e) {
            // 打印异常信息
            Log.e(TAG, e.toString());
            e.printStackTrace();

            // 抛出自定义异常
            throw new ActionFailureException("fail to generate tasklist-update jsonobject");
        }

        return js;
    }

    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
                // id
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    // 如果JSON对象包含ID字段，则将ID设置为相应的值
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                // last_modified
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    // 如果JSON对象包含last_modified字段，则将last_modified设置为相应的值
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

                // name
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    // 如果JSON对象包含name字段，则将name设置为相应的值
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

            } catch (JSONException e) {
                // 打印异常信息
                Log.e(TAG, e.toString());
                e.printStackTrace();

                // 抛出自定义异常
                throw new ActionFailureException("fail to get tasklist content from jsonobject");
            }
        }
    }

    public void setContentByLocalJSON(JSONObject js) {
        // 检查传入的JSON对象是否为空或者不包含指定的字段
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)) {
            // 如果不满足条件，则打印警告信息
            Log.w(TAG, "setContentByLocalJSON: nothing is available");
        }

        try {
            // 获取头部注释的JSON对象
            JSONObject folder = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);

            // 检查头部注释的类型是否为文件夹类型
            if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_FOLDER) {
                // 如果是文件夹类型，则获取文件夹的名称
                String name = folder.getString(NoteColumns.SNIPPET);
                // 将名称设置为预定义前缀加上文件夹名称的形式
                setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + name);
            } else if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_SYSTEM) {
                // 如果是系统类型，则根据特定的系统文件夹ID设置名称
                if (folder.getLong(NoteColumns.ID) == Notes.ID_ROOT_FOLDER)
                    // 如果系统文件夹ID是根文件夹的ID，则设置名称为预定义前缀加上默认文件夹名
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + GTaskStringUtils.FOLDER_DEFAULT);
                else if (folder.getLong(NoteColumns.ID) == Notes.ID_CALL_RECORD_FOLDER)
                    // 如果系统文件夹ID是通话记录文件夹的ID，则设置名称为预定义前缀加上通话笔记文件夹名
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX
                            + GTaskStringUtils.FOLDER_CALL_NOTE);
                else
                    // 如果系统文件夹ID无效，则打印错误信息
                    Log.e(TAG, "invalid system folder");
            } else {
                // 如果类型既不是文件夹类型也不是系统类型，则打印错误信息
                Log.e(TAG, "error type");
            }
        } catch (JSONException e) {
            // 打印异常信息
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }

    /*
     * 从内容中获取本地JSON对象
     */
    public JSONObject getLocalJSONFromContent() {
        try {
            // 创建一个空的JSON对象
            JSONObject js = new JSONObject();
            // 创建一个文件夹JSON对象
            JSONObject folder = new JSONObject();

            // 获取文件夹的名称
            String folderName = getName();
            // 检查文件夹名称是否以预定义前缀开头，如果是，则去掉前缀
            if (getName().startsWith(GTaskStringUtils.MIUI_FOLDER_PREFFIX))
                folderName = folderName.substring(GTaskStringUtils.MIUI_FOLDER_PREFFIX.length(),
                        folderName.length());
            // 将文件夹名称放入文件夹JSON对象中
            folder.put(NoteColumns.SNIPPET, folderName);

            // 检查文件夹名称是否为默认文件夹或通话笔记文件夹，如果是，则设置文件夹类型为系统类型，否则设置为文件夹类型
            if (folderName.equals(GTaskStringUtils.FOLDER_DEFAULT)
                    || folderName.equals(GTaskStringUtils.FOLDER_CALL_NOTE))
                folder.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
            else
                folder.put(NoteColumns.TYPE, Notes.TYPE_FOLDER);

            // 将文件夹JSON对象放入根JSON对象中的头部注释字段中
            js.put(GTaskStringUtils.META_HEAD_NOTE, folder);

            // 返回根JSON对象
            return js;
        } catch (JSONException e) {
            // 打印异常信息
            Log.e(TAG, e.toString());
            e.printStackTrace();
            // 返回空值
            return null;
        }
    }

    /*
     * 获取同步操作类型
     * @param c 数据库游标
     * @return 同步操作类型
     */
    public int getSyncAction(Cursor c) {
        try {
            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // 没有本地更新
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 双方都没有更新
                    return SYNC_ACTION_NONE;
                } else {
                    // 应用远程更新到本地
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // 验证gtask id
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 仅有本地修改
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    // 对于文件夹冲突，只应用本地修改
                    return SYNC_ACTION_UPDATE_REMOTE;
                }
            }
        } catch (Exception e) {
            // 打印异常信息
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }

        // 返回错误的同步操作类型
        return SYNC_ACTION_ERROR;
    }

    /*
     * 获取子任务数量
     * @return 子任务数量
     */
    public int getChildTaskCount() {
        // 直接返回当前任务的子任务列表长度，即子任务数量
        return mChildren.size();
    }

    /*
     * 添加子任务
     * @param task 要添加的子任务
     * @return 是否成功添加
     */
    public boolean addChildTask(Task task) {
        boolean ret = false;
        // 判断要添加的子任务是否为空以及当前任务的子任务列表中是否已经包含该子任务
        if (task != null && !mChildren.contains(task)) {
            // 如果满足条件，则将该子任务添加到子任务列表中
            ret = mChildren.add(task);
            if (ret) {
                // 设置子任务的前一个兄弟和父任务
                task.setPriorSibling(mChildren.isEmpty() ? null : mChildren
                        .get(mChildren.size() - 1));
                task.setParent(this);
            }
        }
        // 返回是否成功添加子任务的信息
        return ret;
    }

    /*
     * 在指定位置添加子任务
     * @param task 要添加的子任务
     * @param index 子任务应该插入的位置
     * @return 是否成功添加
     */
    public boolean addChildTask(Task task, int index) {
        // 判断子任务应该插入的位置是否合法
        if (index < 0 || index > mChildren.size()) {
            // 如果不合法，则记录日志，返回失败
            Log.e(TAG, "add child task: invalid index");
            return false;
        }

        // 查找子任务是否已经在列表中
        int pos = mChildren.indexOf(task);
        // 如果子任务不为空且不在列表中，则执行以下操作
        if (task != null && pos == -1) {
            // 在指定位置添加子任务
            mChildren.add(index, task);

            // 更新任务列表
            Task preTask = null;
            Task afterTask = null;
            if (index != 0)
                preTask = mChildren.get(index - 1);
            if (index != mChildren.size() - 1)
                afterTask = mChildren.get(index + 1);

            // 设置前一个兄弟和后一个兄弟
            task.setPriorSibling(preTask);
            if (afterTask != null)
                afterTask.setPriorSibling(task);
        }

        // 返回是否成功添加子任务的信息
        return true;
    }

    /**
     * 从任务列表中移除指定的子任务
     *
     * @param task 要移除的子任务
     * @return 是否成功移除
     */
    public boolean removeChildTask(Task task) {
        boolean ret = false;
        int index = mChildren.indexOf(task); // 查找子任务在列表中的位置
        if (index != -1) {
            ret = mChildren.remove(task); // 从列表中移除子任务

            if (ret) {
                // 重置前一个兄弟和父任务
                task.setPriorSibling(null); // 将子任务的前一个兄弟设置为null
                task.setParent(null); // 将子任务的父任务设置为null

                // 更新任务列表
                if (index != mChildren.size()) {
                    mChildren.get(index).setPriorSibling(
                            index == 0 ? null : mChildren.get(index - 1)); // 将后一个兄弟的前一个兄弟设置为当前子任务的前一个兄弟
                }
            }
        }
        return ret; // 返回是否成功移除子任务的信息
    }

    /*
     * 移动子任务到指定位置
     * @param task 要移动的子任务
     * @param index 子任务应该移动到的位置
     * @return 是否成功移动
     */
    public boolean moveChildTask(Task task, int index) {

        // 判断子任务应该移动到的位置是否合法
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "move child task: invalid index"); // 记录日志，返回失败
            return false;
        }

        int pos = mChildren.indexOf(task); // 查找子任务在列表中的位置
        // 如果子任务不在列表中，则记录日志，返回失败
        if (pos == -1) {
            Log.e(TAG, "move child task: the task should in the list");
            return false;
        }

        // 如果子任务本来就在目标位置上，则直接返回成功
        if (pos == index)
            return true;

        // 先移除子任务，再添加到指定位置，返回移除和添加的结果
        return (removeChildTask(task) && addChildTask(task, index));
    }

    /*
     * 根据任务的全局ID查找子任务
     * @param gid 任务的全局ID
     * @return 匹配到的子任务，如果未找到则返回null
     */
    public Task findChildTaskByGid(String gid) {
        for (int i = 0; i < mChildren.size(); i++) {
            Task t = mChildren.get(i);
            if (t.getGid().equals(gid)) { // 比较子任务的全局ID与给定的gid是否相等
                return t; // 如果相等，则返回该子任务
            }
        }
        return null; // 如果未找到匹配的子任务，则返回null
    }

    /*
     * 获取子任务在列表中的索引位置
     * @param task 要获取索引的子任务
     * @return 子任务在列表中的索引位置，如果子任务不在列表中则返回-1
     */
    public int getChildTaskIndex(Task task) {
        return mChildren.indexOf(task); // 返回子任务在列表中的索引位置
    }

    /*
     * 根据索引位置获取子任务
     * @param index 子任务在列表中的索引位置
     * @return 索引位置对应的子任务，如果索引位置无效则返回null
     */
    public Task getChildTaskByIndex(int index) {
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "getTaskByIndex: invalid index"); // 记录日志，索引位置无效
            return null;
        }
        return mChildren.get(index); // 返回索引位置对应的子任务
    }

    /*
     * 根据全局ID获取子任务
     * @param gid 任务的全局ID
     * @return 匹配到的子任务，如果未找到则返回null
     */
    public Task getChilTaskByGid(String gid) {
        for (Task task : mChildren) {
            if (task.getGid().equals(gid)) // 比较子任务的全局ID与给定的gid是否相等
                return task; // 如果相等，则返回该子任务
        }
        return null; // 如果未找到匹配的子任务，则返回null
    }

    /*
     * 获取子任务列表
     * @return 子任务列表
     */
    public ArrayList<Task> getChildTaskList() {
        return this.mChildren; // 返回子任务列表
    }

    /*
     * 设置索引位置
     * @param index 索引位置
     */
    public void setIndex(int index) {
        this.mIndex = index; // 设置索引位置
    }

    /*
     * 获取索引位置
     * @return 索引位置
     */
    public int getIndex() {
        return this.mIndex; // 返回索引位置
    }
}
